/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: bufferImpl.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar.impl;

import cheddar.CheddarPackage;

import cheddar.Library.qs_kind;

import cheddar.address_space;
import cheddar.buffer;
import cheddar.buffer_user;
import cheddar.processor;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>buffer</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link cheddar.impl.bufferImpl#getX <em>X</em>}</li>
 *   <li>{@link cheddar.impl.bufferImpl#getY <em>Y</em>}</li>
 *   <li>{@link cheddar.impl.bufferImpl#getCpu_name <em>Cpu name</em>}</li>
 *   <li>{@link cheddar.impl.bufferImpl#getAddress_space_name <em>Address space name</em>}</li>
 *   <li>{@link cheddar.impl.bufferImpl#getBuffer_used_by <em>Buffer used by</em>}</li>
 *   <li>{@link cheddar.impl.bufferImpl#getName <em>Name</em>}</li>
 *   <li>{@link cheddar.impl.bufferImpl#getSize <em>Size</em>}</li>
 *   <li>{@link cheddar.impl.bufferImpl#getQs <em>Qs</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class bufferImpl extends DependencyElementImpl implements buffer {
	/**
	 * The default value of the '{@link #getX() <em>X</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getX()
	 * @generated
	 * @ordered
	 */
	protected static final int X_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getX() <em>X</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getX()
	 * @generated
	 * @ordered
	 */
	protected int x = X_EDEFAULT;

	/**
	 * The default value of the '{@link #getY() <em>Y</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getY()
	 * @generated
	 * @ordered
	 */
	protected static final int Y_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getY() <em>Y</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getY()
	 * @generated
	 * @ordered
	 */
	protected int y = Y_EDEFAULT;

	/**
	 * The cached value of the '{@link #getCpu_name() <em>Cpu name</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCpu_name()
	 * @generated
	 * @ordered
	 */
	protected processor cpu_name = null;

	/**
	 * The cached value of the '{@link #getAddress_space_name() <em>Address space name</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAddress_space_name()
	 * @generated
	 * @ordered
	 */
	protected address_space address_space_name = null;

	/**
	 * The cached value of the '{@link #getBuffer_used_by() <em>Buffer used by</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBuffer_used_by()
	 * @generated
	 * @ordered
	 */
	protected EList buffer_used_by = null;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getSize() <em>Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSize()
	 * @generated
	 * @ordered
	 */
	protected static final int SIZE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getSize() <em>Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSize()
	 * @generated
	 * @ordered
	 */
	protected int size = SIZE_EDEFAULT;

	/**
	 * The default value of the '{@link #getQs() <em>Qs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getQs()
	 * @generated
	 * @ordered
	 */
	protected static final qs_kind QS_EDEFAULT = qs_kind.QS_PP1_LITERAL;

	/**
	 * The cached value of the '{@link #getQs() <em>Qs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getQs()
	 * @generated
	 * @ordered
	 */
	protected qs_kind qs = QS_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected bufferImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CheddarPackage.Literals.BUFFER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getX() {
		return x;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setX(int newX) {
		int oldX = x;
		x = newX;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.BUFFER__X, oldX, x));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getY() {
		return y;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setY(int newY) {
		int oldY = y;
		y = newY;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.BUFFER__Y, oldY, y));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public processor getCpu_name() {
		if (cpu_name != null && cpu_name.eIsProxy()) {
			InternalEObject oldCpu_name = (InternalEObject)cpu_name;
			cpu_name = (processor)eResolveProxy(oldCpu_name);
			if (cpu_name != oldCpu_name) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CheddarPackage.BUFFER__CPU_NAME, oldCpu_name, cpu_name));
			}
		}
		return cpu_name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public processor basicGetCpu_name() {
		return cpu_name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCpu_name(processor newCpu_name) {
		processor oldCpu_name = cpu_name;
		cpu_name = newCpu_name;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.BUFFER__CPU_NAME, oldCpu_name, cpu_name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public address_space getAddress_space_name() {
		if (address_space_name != null && address_space_name.eIsProxy()) {
			InternalEObject oldAddress_space_name = (InternalEObject)address_space_name;
			address_space_name = (address_space)eResolveProxy(oldAddress_space_name);
			if (address_space_name != oldAddress_space_name) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CheddarPackage.BUFFER__ADDRESS_SPACE_NAME, oldAddress_space_name, address_space_name));
			}
		}
		return address_space_name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public address_space basicGetAddress_space_name() {
		return address_space_name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAddress_space_name(address_space newAddress_space_name) {
		address_space oldAddress_space_name = address_space_name;
		address_space_name = newAddress_space_name;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.BUFFER__ADDRESS_SPACE_NAME, oldAddress_space_name, address_space_name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getBuffer_used_by() {
		if (buffer_used_by == null) {
			buffer_used_by = new EObjectContainmentEList(buffer_user.class, this, CheddarPackage.BUFFER__BUFFER_USED_BY);
		}
		return buffer_used_by;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.BUFFER__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getSize() {
		return size;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSize(int newSize) {
		int oldSize = size;
		size = newSize;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.BUFFER__SIZE, oldSize, size));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public qs_kind getQs() {
		return qs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setQs(qs_kind newQs) {
		qs_kind oldQs = qs;
		qs = newQs == null ? QS_EDEFAULT : newQs;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.BUFFER__QS, oldQs, qs));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CheddarPackage.BUFFER__BUFFER_USED_BY:
				return ((InternalEList)getBuffer_used_by()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CheddarPackage.BUFFER__X:
				return new Integer(getX());
			case CheddarPackage.BUFFER__Y:
				return new Integer(getY());
			case CheddarPackage.BUFFER__CPU_NAME:
				if (resolve) return getCpu_name();
				return basicGetCpu_name();
			case CheddarPackage.BUFFER__ADDRESS_SPACE_NAME:
				if (resolve) return getAddress_space_name();
				return basicGetAddress_space_name();
			case CheddarPackage.BUFFER__BUFFER_USED_BY:
				return getBuffer_used_by();
			case CheddarPackage.BUFFER__NAME:
				return getName();
			case CheddarPackage.BUFFER__SIZE:
				return new Integer(getSize());
			case CheddarPackage.BUFFER__QS:
				return getQs();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CheddarPackage.BUFFER__X:
				setX(((Integer)newValue).intValue());
				return;
			case CheddarPackage.BUFFER__Y:
				setY(((Integer)newValue).intValue());
				return;
			case CheddarPackage.BUFFER__CPU_NAME:
				setCpu_name((processor)newValue);
				return;
			case CheddarPackage.BUFFER__ADDRESS_SPACE_NAME:
				setAddress_space_name((address_space)newValue);
				return;
			case CheddarPackage.BUFFER__BUFFER_USED_BY:
				getBuffer_used_by().clear();
				getBuffer_used_by().addAll((Collection)newValue);
				return;
			case CheddarPackage.BUFFER__NAME:
				setName((String)newValue);
				return;
			case CheddarPackage.BUFFER__SIZE:
				setSize(((Integer)newValue).intValue());
				return;
			case CheddarPackage.BUFFER__QS:
				setQs((qs_kind)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case CheddarPackage.BUFFER__X:
				setX(X_EDEFAULT);
				return;
			case CheddarPackage.BUFFER__Y:
				setY(Y_EDEFAULT);
				return;
			case CheddarPackage.BUFFER__CPU_NAME:
				setCpu_name((processor)null);
				return;
			case CheddarPackage.BUFFER__ADDRESS_SPACE_NAME:
				setAddress_space_name((address_space)null);
				return;
			case CheddarPackage.BUFFER__BUFFER_USED_BY:
				getBuffer_used_by().clear();
				return;
			case CheddarPackage.BUFFER__NAME:
				setName(NAME_EDEFAULT);
				return;
			case CheddarPackage.BUFFER__SIZE:
				setSize(SIZE_EDEFAULT);
				return;
			case CheddarPackage.BUFFER__QS:
				setQs(QS_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CheddarPackage.BUFFER__X:
				return x != X_EDEFAULT;
			case CheddarPackage.BUFFER__Y:
				return y != Y_EDEFAULT;
			case CheddarPackage.BUFFER__CPU_NAME:
				return cpu_name != null;
			case CheddarPackage.BUFFER__ADDRESS_SPACE_NAME:
				return address_space_name != null;
			case CheddarPackage.BUFFER__BUFFER_USED_BY:
				return buffer_used_by != null && !buffer_used_by.isEmpty();
			case CheddarPackage.BUFFER__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case CheddarPackage.BUFFER__SIZE:
				return size != SIZE_EDEFAULT;
			case CheddarPackage.BUFFER__QS:
				return qs != QS_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (x: ");
		result.append(x);
		result.append(", y: ");
		result.append(y);
		result.append(", name: ");
		result.append(name);
		result.append(", size: ");
		result.append(size);
		result.append(", qs: ");
		result.append(qs);
		result.append(')');
		return result.toString();
	}

} //bufferImpl