package com.thalesgroup.cheddar.MARTE2cheddar.tools;

/**
 * Describes the planar position of an object
 * <copyright>
 * Thales MARTE to Cheddar (Copyright (c) THALES 2007 All rights reserved) is free software; you can redistribute itand/or modify
 * it under the terms of the Eclipse Public License as published in http://www.eclipse.org/legal/epl-v10.html
 *
 * Thales MARTE to Cheddar is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License for more details.
 * </copyright>
 * @author Nicolas Vienne
 *
 */
public class ObjectPosition {
	
	public static int BASE_X = 0;
	public static int BASE_Y = 0;
	public static int BASE_DX = 150;
	public static int BASE_DY = 100;
	
	public int x;
	public int y;
	public int dx;
	public int dy;
	
	
	public ObjectPosition() {
		x = ObjectPosition.BASE_X;
		y = ObjectPosition.BASE_Y;
		dx = ObjectPosition.BASE_DX;
		dy = ObjectPosition.BASE_DY;
		
	}
	public ObjectPosition(ObjectPosition t) {
		x = t.x;
		y = t.y;
		dx = t.dx;
		dy = t.dy;
	}
}
